



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Winform文件下载之WebClient</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Winform文件下载之WebClient</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 12:36:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近升级了公司内部使用的一个下载小工具，主要提升了下面几点：</p>
<p>1． 在一些分公司的局域网中，连接不上外网</p>
<p>2． 服务器上的文件更新后，下载到的还是更新前的文件</p>
<p>3． 没有下载进度提示</p>
<p>4． 不能终止下载</p>
<p>下面和大家分享一些心得。</p>
<p>鉴于各种复杂的网络环境，笔者决定采用不同的编程接口进行下载尝试，以增加程序的可用性。</p>
<p>这里仅介绍使用WebClient的方法。博文中主要介绍思路和关键代码，完整的demo附在文末。</p>
<h1>使用代理访问网络</h1>
<p>很多公司的员工都是通过公司设置的代理上网的。通过代理上网主要是方便公司进行各种的管制，当然也能实现一些特殊的功能&hellip; 不过这会给我们的程序访问网络带来一些问题。</p>
<p>其实，WebClient中的API已经很智能了，比如我们创建的HttpWebRequest对象，它自带一个Proxy属性。也就是说，WebHttpRequest默认会使用找到的代理。这很棒，也能处理很多情况了。可是如果这个默认的代理需要验证域用户的身份信息，这时使用WebHttpRequest访问网络就可能失败。此时查看 Proxy. Credentials属性，发现它是null.</p>
<p>从WebClient的API中是可以取到系统默认的Credentials的，只是不太清楚为什么Proxy.Credentials属性默认没有设置为这个值。我们自己设置下就可以了。</p>
<div>
<pre class="prettyprint linenums">request.Proxy.Credentials = CredentialCache.DefaultCredentials;</pre>
</div>
<p>但实际的网络环境可能会更复杂，需要用户来指定联网的代理，并同时指定联网所需的Credentials。写法如下：</p>
<div>
<pre class="prettyprint linenums">myProxy = new WebProxy(&ldquo;proxyAddress&rdquo;); 

myProxy.Credentials = new NetworkCredential(ProxyUserName, ProxyUserPasswd, DomainName);</pre>
</div>
<h1>克服缓存</h1>
<p>缓存可谓无处不再，在服务器端CDN会有缓存，在客户端的代理层也会有缓存。所以经常出现的问题是：服务器上的文件明明更新了，还是会有一些客户下载到旧文件。我们先来处理客户端的缓存问题。</p>
<p>HttpWebRequest的CachePolicy.Level属性就是设置缓存策略的，只是它的默认值是 BypassCache. 我们把它改为 Reload就行了:</p>
<div>
<pre class="prettyprint linenums">request.CachePolicy = new System.Net.Cache.RequestCachePolicy(System.Net.Cache.RequestCacheLevel.Reload);
 </pre>
</div>
<p>接下是服务器端的缓存问题。</p>
<p>现在大家好像都在使用CDN，可在使用中经常发现CDN端的缓存更新有问题。在网上查了查也没有什么好的解决办法，不过倒是有一个很好的workaround，就是在请求中添加一个随机的字符串作为参数。</p>
<div>
<pre class="prettyprint linenums">Random rdm = new Random();

string s = rdm.Next().ToString();

myUrl += "?" + s;</pre>
</div>
<p>需要注意的是，关于缓存，一定要使用符合当前用例的策略，且不可搞一刀切。</p>
<h1>更友好的下载过程</h1>
<p>使用滚动条显示下载进度，显示实时的下载速度，允许用户取消下载</p>
<p>下面是下载用的核心代码，我们把它分为计算下载百分比和计算当前下载速度分别介绍。</p>
<p>// 获得下载文件的长度</p>
<div>
<pre class="prettyprint linenums">double contentLength = DownloadManager.GetContentLength(myHttpWebClient);

byte[] buffer = new byte[BufferSize];

long downloadedLength = ;

long currentTimeSpanDataLength = ;         

int currentDataLength;

while ((currentDataLength = stream.Read(buffer, , BufferSize)) &gt;  &amp;&amp; !this._cancelDownload)

{

    fileStream.Write(buffer, , currentDataLength);

    downloadedLength += (long)currentDataLength;

    currentTimeSpanDataLength += (long)currentDataLength;

    int intDownloadSpeed = ;

    if (this._downloadStopWatch.ElapsedMilliseconds &gt; )

    {

        double num5 = (double)currentTimeSpanDataLength / 1024.0;

        double num6 = (double)this._downloadStopWatch.ElapsedMilliseconds / 1000.0;

        double doubleDownloadSpeed = num5 / num6;

        intDownloadSpeed = (int)Math.Round(doubleDownloadSpeed, );

        this._downloadStopWatch.Reset();

        this._downloadStopWatch.Start();

        currentTimeSpanDataLength = ;

    }

    double doubleDownloadPersent = 0.0;

    if (contentLength &gt; 0.0)

    {

        doubleDownloadPersent = (double)downloadedLength / contentLength;

}

}
</pre>
</div>
<h2>在下载的过程中计算下载百分比</h2>
<p>首先需要从http请求中获得要下载文件的长度，细节请参考本文所配demo.</p>
<div>
<pre class="prettyprint linenums">double contentLength = DownloadManager.GetContentLength(myHttpWebClient);</pre>
</div>
<p>每从文件流中读取一次数据，我们知道读了多少个字节(currentDataLength)，累计下来就是当前已经下载了的文件长度。</p>
<div>
<pre class="prettyprint linenums">downloadedLength += (long)currentDataLength;</pre>
</div>
<p>然后做个除法就行了：</p>
<div>
<pre class="prettyprint linenums">doubleDownloadPersent = (double)downloadedLength / contentLength;</pre>
</div>
<h2>计算实时的下载速度</h2>
<p>对于当前的下载速度，我们计算过去的一段时间内下载下来的字节数。时间段可以使用StopWatch来获得，我选择的时间段要求大于800毫秒。</p>
<div>
<pre class="prettyprint linenums">if (this._downloadStopWatch.ElapsedMilliseconds &gt; )

{

    /***********************************/

    // 计算上一个时间段内的下载速度

    double num5 = (double)currentTimeSpanDataLength / 1024.0;

    double num6 = (double)this._downloadStopWatch.ElapsedMilliseconds / 1000.0;

    double doubleDownloadSpeed = num5 / num6;

    /***********************************/

intDownloadSpeed = (int)Math.Round(doubleDownloadSpeed, );

// 本次网速计算完成后重置时间计时器和数据计数器，开始下次的计算

    this._downloadStopWatch.Reset();

    this._downloadStopWatch.Start();

    currentTimeSpanDataLength = ;

}</pre>
</div>
<p>事实上每次计算下载速度的时间段长度是不固定的，但这并不影响计算结果，我只要保证距离上次计算超过了800毫秒就行了。</p>
<h2>允许用户取消下载</h2>
<p>对于一个执行时间比较长的任务来说，不允许用户取消它是被深恶痛绝的！尤其是网速不太好的时候。所以我们需要给用户一个选择：可以痛快(而不是痛苦)的结束当前的旅程。</p>
<p>而这一切对我们来说又是那么的简单！</p>
<div>
<pre class="prettyprint linenums">while ((currentDataLength = stream.Read(buffer, , BufferSize)) &gt;  &amp;&amp; !this._cancelDownload){}</pre>
</div>
<p>当从数据流中读取数据时，我们检查用户是不是按下了&ldquo;取消&rdquo;按钮，就是这里的 this._cancelDownload 变量。如果它是 true就结束当前的下载。</p>
<p>至此，把用户抱怨最多的几个点都搞定了。其实也没有增加多少代码，并且每个知识点看起来都是那么的细微。但很明显的提高了用户的使用体验。这也给我们带来了一些启发，完成主要功能可能只是工作中的一部分，另外的一些工作可能并不是那么明显，需要我们不断的体会，发觉&hellip;</p>
<p><strong><a href="http://files.cnblogs.com/files/powertoolsteam/WebClientDemo.zip" rel="external nofollow noreferrer">Demo 下载</a></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kjex59.html">HTML基础知识汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnddkg8.html">清北学堂模拟赛day7 石子合并加强版</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kmrzr9.html">C&plus;&plus; 判断字符串是否全是数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qymro2q.html">基于EventAggregator的事件发布及订阅</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11jmj9.html">C&plus;&plus;&mdash;&mdash;将成员函数作为参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok11wx9.html">Android ImageButton android&colon;scaleType</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ypn7jq.html">jquery&period;form&period;js实现将form提交转为ajax方式提交的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xp66n9.html">关于frameset中指定区域回退的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdm5g9.html">解决ArcGIS Android Could not find class &amp;&num;39&semi;com&period;esri&period;android&period;map&period;MapView&amp;&num;39&semi;问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj0ym8.html">Ildasm&period;exe 概要：</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdn2v38.html">Java创建Oracle数据库表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0e569.html">WinDbg分析DUMP文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m5vjm8.html">【网络流】【BZOJ1061】【NOI2008】志愿者招募</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gey3zl8.html">CSS &colon;focus 选择器</a>
		</li>
						<li><a href="https://www.batexi.com/a/950od068.html">pyecharts使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwzk38.html">springmvc 配置之 mvc&colon;default-servlet-handler</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wnwxnq.html">python操作三大主流数据库&lpar;2&rpar;python操作mysql②python对mysql进行简单的增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1wn35q.html">Windows 10 MBR转GPT</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnveoy38.html">error&colon; Microsoft Visual C&plus;&plus; 14&period;0 is required（line&lowbar;profiler模块安装失败的解决办法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvey1lz9.html">开源一款强大的文件服务组件（QJ&lowbar;FileCenter）（系列二 安装说明）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8o3de58.html">liunx 字符编码问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p7kkd9.html">Encapsulation、Inheritance、Polymorphism</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq47ndnq.html">安卓稳定性压测工具&lowbar;monkey环境搭建&lpar;简易&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z64z1q.html">Linux下TCP网络编程与基于Windows下C&num;socket编程间通信</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qngw2j8.html">R语言数据处理利器&mdash;&mdash;dplyr简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qngw7x8.html">viojs1908无线网路发射器选址</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z66mvq.html">8&period;4&period;1 ImageLoader</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gzrk78.html">&lbrack;XAF&rsqb; How to represent an enumeration property via a drop-down box with check boxes</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z6lgvq.html">基于AutoCAD的ObjectARX之NET扩展&lpar;mcnetarx&rpar;-AcdbEntMake</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvjn0zq.html">Win7系统修改hosts文件不能保存的解决方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
